#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include "tcl.h"

int tcl_parse(ClientData, Tcl_Interp *, int, char **);

parse_init(interp)
Tcl_Interp *interp;
{
	Tcl_CreateCommand(interp, "parse", tcl_parse,
		(ClientData)0L,(void (*)()) NULL);

	return TCL_OK;
}

int tcl_parse(dummy, interp, argc, argv)
ClientData dummy;
Tcl_Interp *interp;
int argc;
char **argv;
{
	int pos, orig_pos;
	int x = 1;
	char tmp[1024];
	char tmp2[1024];
	char line[1024], delimeter[10];
	int field;

	if(argc < 4) {
		Tcl_AppendResult(interp, "wrong # args: should be ", argv[0],
					" string delimeter field", (char *) NULL);
		return TCL_ERROR;
	}

	strcpy(line, argv[1]);
	strcpy(delimeter, argv[2]);
	field = atoi(argv[3]);


	if((pos = strfind(line, delimeter)) == -1) {   /* Can't find any delimeter*/
		memset(tmp, '\0', sizeof(tmp));            /* return original line    */
		strcpy(tmp, line);
		Tcl_AppendResult(interp, tmp, (char *) NULL);
		return(TCL_OK);
	}

	orig_pos = pos; 

	if(field == 1) {
		memset(tmp, '\0', sizeof(tmp));
		strncpy(tmp, line, pos);
		Tcl_AppendResult(interp, tmp, (char *) NULL);
		return(TCL_OK);
	} else {
		strcpy(tmp, line);
		while(x != field) {
			memset(tmp2, '\0', sizeof(tmp));
			strcpy(tmp, line + (orig_pos + (strlen(delimeter) * x)));
			x++;
			if((pos = strfind(tmp, delimeter)) == -1) {
				if(x < field) {					/* ran out of columns before */
					Tcl_AppendResult(interp, 	/* 'field' was reached.      */
							"field is greater than number of columns", 
							(char *) NULL);
					return TCL_ERROR;
				} else {
					strcpy(tmp2, tmp);			/* found 'field' */
					break;
				}
			}
			orig_pos += pos;
			strncpy(tmp2, tmp, pos);
		}

		Tcl_AppendResult(interp, tmp2, (char *) NULL);

		return(TCL_OK);
	}
}
